/* 

   Multithreaded C Program Using the Pthread API 
   compile with:
   gcc pthread_02.c -o pthread_02 -pthread 

*/

#include <stdio.h>
#include <pthread.h>

int glob_data = 5 ;

void *kidfunc(void *p) {
 printf ("Kid here. Global data was %d.\n", glob_data) ;
 glob_data = 15 ;
 printf ("Kid Again. Global data was now %d.\n", glob_data) ;
}

int main() {
 pthread_t kid ;
 for(int i=0; i<5; i++){
 pthread_create (&kid, NULL, kidfunc, NULL) ;
 printf ("Parent here. Global data = %d\n", glob_data) ;
 glob_data = 10 ;
 pthread_join (kid, NULL) ;
 printf ("End of program. Global data = %d\n", glob_data) ;
 printf ("----------/// \n ");
 }
 return 0;
} 


/*

---------------///

Parent here. Global data = 5
Kid here. Global data was 5.
Kid Again. Global data was now 15.
End of program. Global data = 15

--------------///

Kid here. Global data was 5.
Kid Again. Global data was now 15.
Parent here. Global data = 5
End of program. Global data = 10

-------------///

Parent here. Global data = 5
Kid here. Global data was 10.
Kid Again. Global data was now 15.
End of program. Global data = 15

------------///

*/


