/* 

   Multithreaded C Program Using the Pthread API 
   compile with:
   gcc pthread_04.c -o pthread_04 -pthread 

*/

#include <pthread.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <unistd.h>

#define NUM_THREADS 5

void *PrintHello(void *threadid)
{
   printf("\nThread ID %ld: Hello World!\n", pthread_self());
  pthread_exit(NULL);
}

int main()
{
  pthread_t threads[NUM_THREADS];
  int rc, t;
  for(t=0; t < NUM_THREADS; t++) {
 // sleep(1);
  printf ("Creating thread #%d\n",t);   
  rc = pthread_create(&threads[t], NULL, PrintHello, NULL );
   if (rc) {
   printf("ERROR; return code from pthread_create() is %d\n", rc);
   exit(-1);
   }
  }
  pthread_exit(NULL);
  return 0;
} 

/*
Creating thread #0
Creating thread #1

Thread ID 139648709900032: Hello World!

Thread ID 139648701507328: Hello World!
Creating thread #2
Creating thread #3

Thread ID 139648693114624: Hello World!
Creating thread #4

Thread ID 139648684721920: Hello World!

Thread ID 139648674133760: Hello World!

*/
